   renoise.tool():add_keybinding {
  name = "Global:Tools:TickyRoll",
  invoke = function()render_notes()end
}


  function my_keyhandler_func(dialog, key)
  
      if (key.modifiers == "" and key.name == "esc") then
        dialog:close()
      end
    
      if  key.name ~= "esc" then
        return key
      end
  end 
  

  function my_fill_pattern_notes_table(pattern_notes,iteration)
      
     --all to false      
     for i = 1,121 do --fill with 121 falses
         pattern_notes[i] = false
     end
   
       --add trues
     for i = 1,12 do
      pattern_notes[iteration[i]+1] = true 
     end

  end
  

---------------------------------------------------------------------------------------------------
--Main()
---------------------------------------------------------------------------------------------------
  
  function render_notes()

  
  
     local note_strings = {
     
    "C0", "", "D", "", "E", "F", 
    "", "G", "", "A", "", "B",
    
    "C1", "", "D", "", "E", "F", 
    "", "G", "", "A", "", "B",
    
    "C2", "", "D", "", "E", "F", 
    "", "G", "", "A", "", "B",
    
    "C3", "", "D", "", "E", "F", 
    "", "G", "", "A", "", "B",
    
    "C4", "", "D", "", "E", "F", 
    "", "G", "", "A", "", "B",
    
    "C5", "", "D", "", "E", "F", 
    "", "G", "", "A", "", "B",
    
    "C6", "", "D", "", "E", "F", 
    "", "G", "", "A", "", "B",
    
    "C7", "", "D", "", "E", "F", 
    "", "G", "", "A", "", "B",
    
    "C8", "", "D", "", "E", "F", 
    "", "G", "", "A", "", "B",
    
    "C9", "", "D", "", "E", "F", 
    "", "G", "", "A", "", "B"
    
     }
  
  
    local current_line = 1
    local current_line_2 = 1
    local iter_incrementor = 1
    
   
    local iteration = {}
    local pattern_notes = {}


    local pattern_iter = renoise.song().pattern_iterator
    local pattern_index = renoise.song().selected_pattern_index
    local track_index = renoise.song().selected_track_index
    local my_row_index = renoise.song().selected_line_index
    



  --iterate the selected track line (get notes)

   for pos,line in pattern_iter:note_columns_in_pattern_track(pattern_index,track_index) do
             
          if pos.line > my_row_index  then         
            break
          end
         
          if pos.line == my_row_index then        
            iteration[iter_incrementor] = line.note_value
            iter_incrementor = iter_incrementor +1
          end                    
   
   end 
   
   --fill pattern_notes {}
    
   my_fill_pattern_notes_table(pattern_notes,iteration)    

 ---------------------------------------------------------------------------------
-- GUI
 ----------------------------------------------------------------------------------
  
   local vb = renoise.ViewBuilder()
   local CONTENT_SPACING = renoise.ViewBuilder.DEFAULT_CONTROL_SPACING
  
   local tick_boxes = vb:row {}
   local note_text = vb:row {}
  
  
local num_of_rows = 16  


 for row = 1, num_of_rows do --16 rows for now
    local each_row = vb:row {}
  
  
  ----- Write note names for top row 
 
  for i = 1,120 do
       
       local note_names = vb:text {
             text = note_strings[i],
             align = "center",
             width = "20%"
             
             }
             
       note_text:add_child(note_names)      
     
   end

---- create checkboxes for second row
    
    for i = 1,120 do
    
    local holder = not pattern_notes[i]
    
       local note_boxes = vb:checkbox {
             value = pattern_notes[i],
             width = 18,
            -- id = "cb_"..row..i,
             
 ---------------------------------------------------            
            
             notifier = function(state) --Checkbox notifier
   
      
     
  --iterate the selected track line (get notes)

   for pos,line in pattern_iter:note_columns_in_pattern_track(pattern_index,track_index) do
             
          if pos.line > my_row_index  then         
            break
          end
         
          if pos.line == my_row_index then        
            iteration[iter_incrementor] = line.note_value
            iter_incrementor = iter_incrementor +1
          end                    
   
   end 
   
   --fill pattern_notes
    
   my_fill_pattern_notes_table(pattern_notes,iteration) 
   
    
    
  local inst_index = renoise.song().selected_instrument_index
 
-------------------------------------------------------------------------------------------------------
--add and remove notes
-----------------------------------------------------------------------------------------------------
      
         holder = not holder  --inverts boolean
        
          if holder then --note to delete
 
           
             for pos,line in   pattern_iter:note_columns_in_pattern_track(pattern_index,track_index) do --iterate when unchecking box
                    
                     if pos.line == my_row_index then --current row
                       
                        if line.note_value == i -1 then
                          line.note_value = 121
                          line.instrument_value = 255 --empty
                         break
                        end
                     end
                     
                     
                    
                     if  pos.line > my_row_index then
                       break
                     end
                                     
             end 
         
         
         
          else -- note to add
          
            for pos,line in   pattern_iter:note_columns_in_pattern_track(pattern_index,track_index) do--iter for + note i.e. checking box
                  
                  
                if pos.line == my_row_index then
                   if line.note_value == 121 then
                      line.note_value = i-1
                      line.instrument_value = inst_index -1
                      
                       --expand track
                     if not 
                         renoise.song().patterns[pattern_index].tracks[track_index].lines[pos.line].note_columns[pos.column].is_empty then  --pos empty

                        if
                          renoise.song().tracks[track_index].visible_note_columns < pos.column then 
                          renoise.song().tracks[track_index].visible_note_columns = pos.column 
                        end
                     end
   
                    break
                   end 
                end 
                
                
                
                 if  pos.line > my_row_index then  --Max 12 Notes                
                 renoise.app():show_status("Track Row Full: Only 12 Events Possible Per Row")   
                 vb.views["cb_"..i].value = not state --reset current cbox to off  
                  break
                 end
            end
         
          end 
        
------------------------------------------------------------------------------------------
--Re-iterate again so ready for next time --[3]--
------------------------------------------------------------------------------------------

--iterate the selected track line (get notes)

   for pos,line in pattern_iter:note_columns_in_pattern_track(pattern_index,track_index) do
             
          if pos.line > my_row_index  then         
            break
          end
         
          if pos.line == my_row_index then        
            iteration[iter_incrementor] = line.note_value
            iter_incrementor = iter_incrementor +1
          end                    
   
   end 
   
   --fill pattern_notes {}
    
   my_fill_pattern_notes_table(pattern_notes,iteration) 
   
-------------------------------------------------------------------------------------------        

        
      end, --notifier function end
    }
           
   tick_boxes:add_child(note_boxes) 
            
   
   end --create checkboxes `for` end

end--each_row (for)      
---------------------------------------------------------------------------------------------
 
--put together the dialog contents

 local dialog_content = vb:column {
       margin = 2,
       spacing = CONTENT_SPACING,
      -- vb:horizontal_aligner {mode = "center",title_row},
       note_text,
       tick_boxes
    
       }

 
  renoise.app():show_custom_dialog("                                                                                                                                                                                                                                                                                                                                                      Tick Piano |  "..renoise.song().tracks[track_index].name.."  Row:  "..(my_row_index -1), dialog_content,my_keyhandler_func)

end



  -- local title_row = vb:column {}
  
  ----------------------------------------------add Track Name and row number TODO
  
--  local title =  vb:text {
 --       text = renoise.song().tracks[track_index].name.." Row:  "..my_row_index.."\n",
 --       font = "bold"
 --       }
    
 --  title_row:add_child(title)
  


